	LD	SP,0FF00H
	LD	IX,0FE00H
; The first variable 9.876543 is entered into memory
; Using the provided tool you can change these values
	LD	BC,411EH
	LD	DE,0652H
	LD	(IX-04H),E
	LD	(IX-03H),D
	LD	(IX-02H),C
	LD	(IX-01H),B
; The second variable 2.345678 is entered into memory
; Using the provided tool you can change these values
	LD	BC,4016H
	LD	DE,1F97H
	LD	(IX-08H),E
	LD	(IX-07H),D
	LD	(IX-06H),C
	LD	(IX-05H),B

; There are three blocks of mathematical function calls, because
; different math functions are called in different ways.
; So, when you want to assebmle this listing you should leave
; only one block and delete or put in comment the other two blocks.

; Block 1
; ADD, SUB, MUL and DIV functions
	LD	E,(IX-04H)
	LD	D,(IX-03H)
	LD	C,(IX-02H)
	LD	B,(IX-01H)
	PUSH	BC
	PUSH	DE
	LD	E,(IX-08H)
	LD	D,(IX-07H)
	LD	C,(IX-06H)
	LD	B,(IX-05H)
; Only one of these 4 CALLs should be leaved without a comment sign
;ADD	CALL	L0013
;SUB	CALL	L0012
;MUL	CALL	L0029
;DIV	CALL	L0037
	LD	(IX-0CH),E
	LD	(IX-0BH),D
	LD	(IX-0AH),C
	LD	(IX-09H),B
	HALT

; When the HALT state is reached,
; the result will be hold in B, C, D and E registers.

; Block 2
; SQRT, LOG, LOG10, EXP, SIN, COS and TAN functions
	LD	E,(IX-04H)
	LD	D,(IX-03H)
	LD	C,(IX-02H)
	LD	B,(IX-01H)
	PUSH	BC
	PUSH	DE
; Only one of these 7 CALLs should be leaved without a comment sign
;SQRT	CALL	L0069
;LOG	CALL	L0096
;LOG10	CALL	L0105
;EXP	CALL	L0088
;SIN	CALL	L0119
;COS	CALL	L0078
;TAN	CALL	L0120
	POP	HL
	POP	HL
	LD	(IX-0CH),E
	LD	(IX-0BH),D
	LD	(IX-0AH),C
	LD	(IX-09H),B
	HALT

; When the HALT state is reached,
; the result will be hold in B, C, D and E registers.

; Block 3
; POW function
	LD	E,(IX-08H)
	LD	D,(IX-07H)
	LD	C,(IX-06H)
	LD	B,(IX-05H)
	PUSH	BC
	PUSH	DE
	LD	E,(IX-04H)
	LD	D,(IX-03H)
	LD	C,(IX-02H)
	LD	B,(IX-01H)
	PUSH	BC
	PUSH	DE
	CALL	L0109
	POP	HL
	POP	HL
	POP	HL
	POP	HL
	LD	(IX-0CH),E
	LD	(IX-0BH),D
	LD	(IX-0AH),C
	LD	(IX-09H),B
	HALT

; When the HALT state is reached,
; the result will be hold in B, C, D and E registers.




; The mathematical routines start here.
; Nothing should be changed from here to the end of listing.
L0010:	RES	7,B
	RET
L0011:	EXX
	POP	HL
	POP	DE
	POP	BC
	PUSH	HL
	LD	A,B
	XOR	80H
	LD	B,A
	EXX
	CALL	L0014
	RET
L0012:	LD	A,B
	XOR	80H
	LD	B,A
L0013:	EXX
	POP	HL
	POP	DE
	POP	BC
	PUSH	HL
	EXX
L0014:	PUSH	HL
	CALL	L0015
	CALL	L0058
	POP	HL
	RET
L0015:	EXX
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	EXX
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
L0016:	LD	A,C
	EXX
	SUB	C
	JR	Z,L0018
	JR	NC,L0017
	NEG
	EXX
L0017:	SRL	D
	RR	E
	RR	H
	RR	L
	INC	C
	DEC	A
	JR	NZ,L0017
L0018:	LD	A,B
	EXX
	XOR	B
	EXX
	JP	M,L0020
	LD	A,L
	EXX
	ADD	A,L
	EXX
	LD	L,A
	LD	A,H
	EXX
	ADC	A,H
	EXX
	LD	H,A
	LD	A,E
	EXX
	ADC	A,E
	EXX
	LD	E,A
	LD	A,D
	EXX
	ADC	A,D
	EXX
	LD	D,A
	JR	NC,L0023
L0019:	LD	A,D
	RR	D
	RR	E
	RR	H
	RR	L
	OR	C
	OR	E
	OR	H
	OR	L
	JR	Z,L0023
	INC	C
	JR	L0023
L0020:	LD	A,D
	EXX
	CP	D
	JR	C,L0022
	JR	NZ,L0021
	LD	A,E
	EXX
	CP	E
	JR	C,L0022
	JR	NZ,L0021
	LD	A,H
	EXX
	CP	H
	JR	C,L0022
	JR	NZ,L0021
	LD	A,L
	EXX
	CP	L
	JR	C,L0022
L0021:	EXX
L0022:	LD	A,L
	EXX
	SUB	L
	EXX
	LD	L,A
	LD	A,H
	EXX
	SBC	A,H
	EXX
	LD	H,A
	LD	A,E
	EXX
	SBC	A,E
	EXX
	LD	E,A
	LD	A,D
	EXX
	SBC	A,D
	EXX
	LD	D,A
	JR	C,L0019
L0023:	RET
L0024:	PUSH	HL
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	EXX
	LD	BC,007FH
	LD	DE,8000H
	LD	H,E
	LD	L,E
	CALL	L0016
	CALL	L0058
	POP	HL
	RET
L0025:	PUSH	HL
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	EXX
	LD	BC,807FH
	LD	DE,8000H
	LD	L,E
	LD	H,E
	CALL	L0016
	CALL	L0058
	POP	HL
	RET
L0026:	LD	A,80H
	SUB	B
	JR	NZ,L0027
	LD	B,A
L0027:	EXX
	POP	HL
	POP	DE
	POP	BC
	PUSH	HL
	LD	A,80H
	SUB	B
	JR	NZ,L0028
	LD	B,A
L0028:	LD	A,B
	EXX
	CP	B
	RET	NZ
	EXX
	LD	A,C
	EXX
	CP	C
	RET	NZ
	EXX
	LD	A,D
	EXX
	CP	D
	RET	NZ
	EXX
	LD	A,E
	EXX
	CP	E
	RET
L0029:	EXX
	POP	HL
	POP	DE
	POP	BC
	PUSH	HL
	EXX
	PUSH	HL
	EXX
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	JR	Z,L0030
	EXX
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	JR	Z,L0030
	CALL	L0031
L0030:	CALL	L0058
	POP	HL
	RET
L0031:	LD	A,B
	EXX
	XOR	B
	LD	B,A
	LD	A,C
	EXX
	SUB	7FH
	LD	B,A
	LD	A,C
	SUB	7FH
	ADD	A,B
	JP	PO,L0033
	EXX
	LD	HL,0002H
	LD	(0FD00H),HL
	LD	C,0FFH
	JR	NC,L0032
	INC	C
L0032:	LD	D,C
	LD	E,C
	LD	H,C
	LD	L,00H
	RET
L0033:	ADD	A,80H
	EXX
	LD	C,A
	PUSH	BC
	PUSH	DE
	LD	B,H
	LD	C,L
	EXX
	POP	BC
	PUSH	HL
	EXX
	POP	DE
	LD	A,20H
L0034:	DEC	C
	INC	C
	JR	NZ,L0035
	CP	09H
	JR	C,L0035
	SUB	08H
	PUSH	AF
	EXX
	LD	A,C
	LD	C,B
	LD	B,00H
	EXX
	LD	C,B
	LD	B,A
	EXX
	LD	A,L
	LD	L,H
	LD	H,00H
	EXX
	LD	L,H
	LD	H,A
	POP	AF
	JR	L0034
L0035:	EXX
	SRL	B
	RR	C
	EXX
	RR	B
	RR	C
	JR	NC,L0036
	ADD	HL,DE
	EXX
	ADC	HL,DE
	EXX
L0036:	EXX
	RR	H
	RR	L
	EXX
	RR	H
	RR	L
	DEC	A
	JR	NZ,L0034
	EXX
	PUSH	HL
	EXX
	POP	DE
	POP	BC
	RET
L0037:	EXX
	POP	HL
	POP	DE
	POP	BC
	PUSH	HL
	EXX
	PUSH	HL
	EXX
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	JR	Z,L0039
	EXX
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	JR	NZ,L0038
	LD	HL,0001H
	LD	(0FD00H),HL
	LD	C,00H
	JR	L0040
L0038:	CALL	L0041
L0039:	CALL	L0058
L0040:	POP	HL
	RET
L0041:	LD	A,C
	SUB	7FH
	LD	C,A
	LD	A,B
	EXX
	XOR	B
	LD	B,A
	LD	A,C
	PUSH	DE
	EXX
	SUB	7FH
	SUB	C
	JP	PO,L0042
	POP	DE
	LD	HL,0002H
	LD	(0FD00H),HL
	LD	C,00H
	RET
L0042:	ADD	A,7FH
	LD	B,H
	LD	C,L
	POP	HL
	PUSH	BC
	EXX
	LD	C,A
	POP	DE
	PUSH	BC
	LD	A,20H
L0043:	OR	A
	SBC	HL,DE
	EXX
	SBC	HL,DE
	EXX
	CCF
	JR	C,L0044
	ADD	HL,DE
	EXX
	ADC	HL,DE
	EXX
	OR	A
L0044:	RL	C
	RL	B
	EXX
	RL	C
	RL	B
	BIT	7,H
	EXX
	JR	NZ,L0045
	ADD	HL,HL
	EXX
	ADC	HL,HL
	EXX
	JR	L0046
L0045:	EXX
	SRL	D
	RR	E
	EXX
	RR	D
	RR	E
L0046:	DEC	A
	JR	NZ,L0043
	EXX
	PUSH	BC
	EXX
	LD	H,B
	LD	L,C
	POP	DE
	POP	BC
	RET
L0047:	PUSH	HL
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	LD	A,C
	SUB	7FH
	JR	NC,L0049
L0048:	LD	BC,0000H
	LD	D,C
	LD	E,C
	JR	L0052
L0049:	NEG
	ADD	A,1FH
	JR	Z,L0051
	CP	20H
	JR	NC,L0048
L0050:	SRL	D
	RR	E
	RR	H
	RR	L
	DEC	A
	JR	NZ,L0050
L0051:	BIT	7,B
	LD	B,D
	LD	C,E
	EX	DE,HL
	JR	Z,L0052
	CALL	L0076
L0052:	POP	HL
	RET
L0053:	LD	E,A
	RLCA
	SBC	A,A
	LD	D,A
	CALL	L0054
	RET
L0054:	PUSH	HL
	EX	DE,HL
	LD	DE,0000H
	LD	B,H
	BIT	7,B
	JR	Z,L0055
	EX	DE,HL
	OR	A
	SBC	HL,DE
	LD	DE,0000H
L0055:	LD	C,9EH
	CALL	L0058
	POP	HL
	RET
L0056:	PUSH	HL
	LD	A,B
	BIT	7,B
	JR	Z,L0057
	CALL	L0076
	LD	A,80H
L0057:	EX	DE,HL
	LD	E,C
	LD	D,B
	LD	B,A
	LD	C,9EH
	CALL	L0058
	POP	HL
	RET
L0058:	LD	A,C
	OR	A
	JR	NZ,L0060
L0059:	LD	B,A
	LD	E,A
	LD	D,A
	RET
L0060:	BIT	7,D
	JR	NZ,L0061
	LD	A,C
	OR	A
	JR	Z,L0059
	DEC	C
	SLA	L
	RL	H
	RL	E
	RL	D
	JP	L0060
L0061:	LD	A,L
	ADD	A,80H
	LD	A,H
	ADC	A,00H
	LD	L,A
	LD	A,E
	ADC	A,00H
	LD	H,A
	LD	A,D
	ADC	A,00H
	JR	NC,L0062
	INC	C
L0062:	ADD	A,A
	SRL	C
	RRA
	LD	E,A
	LD	A,B
	AND	80H
	OR	C
	LD	D,A
	LD	B,D
	LD	C,E
	EX	DE,HL
	RET
L0063:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	PUSH	BC
	PUSH	DE
	PUSH	BC
	PUSH	DE
	LD	B,(IX+0BH)
	LD	C,(IX+0AH)
	LD	D,(IX+09H)
	LD	E,(IX+08H)
	CALL	L0037
	CALL	L0047
	CALL	L0056
	PUSH	BC
	PUSH	DE
	LD	B,(IX+0BH)
	LD	C,(IX+0AH)
	LD	D,(IX+09H)
	LD	E,(IX+08H)
	CALL	L0029
	CALL	L0012
	POP	IX
	RET
L0064:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	JR	NZ,L0065
	LD	D,00H
	JR	L0066
L0065:	PUSH	BC
	LD	C,7EH
	CALL	L0058
	POP	HL
	LD	A,L
	SUB	7EH
	LD	L,A
	RLCA
	SBC	A,A
	LD	H,A
	EX	DE,HL
L0066:	PUSH	HL
	LD	H,(IX+09H)
	LD	L,(IX+08H)
	LD	(HL),E
	INC	HL
	LD	(HL),D
	POP	DE
	POP	IX
	RET
L0067:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	PUSH	HL
	LD	H,(IX+09H)
	LD	L,(IX+08H)
	LD	A,C
	ADD	A,L
	LD	C,A
	POP	HL
	CALL	L0058
	POP	IX
	RET
L0068:	PUSH	BC
	PUSH	DE
	CALL	L0029
	RET
L0069:	BIT	7,B
	JR	Z,L0070
	LD	HL,0001H
	LD	(0FD00H),HL
	EX	DE,HL
	DEC	DE
	LD	B,D
	LD	C,E
	RET
L0070:	LD	L,00H
	LD	H,E
	LD	E,D
	LD	D,C
	SET	7,D
	RL	C
	LD	A,B
	ADC	A,A
	LD	C,A
	JP	Z,L0075
	PUSH	BC
	PUSH	DE
	PUSH	HL
	EXX
	POP	HL
	POP	DE
	POP	BC
	PUSH	BC
	PUSH	DE
	PUSH	HL
	EXX
	LD	A,C
	SUB	7FH
	RRA
	ADD	A,7FH
	LD	C,A
	LD	A,04H
	JR	L0072
L0071:	EXX
	POP	HL
	POP	DE
	POP	BC
	PUSH	BC
	PUSH	DE
	PUSH	HL
	EXX
L0072:	PUSH	AF
	PUSH	BC
	PUSH	DE
	PUSH	HL
	CALL	L0041
	EXX
	POP	HL
	POP	DE
	POP	BC
	EXX
	CALL	L0016
	LD	A,D
	OR	E
	OR	H
	OR	L
	JR	Z,L0074
	DEC	C
L0073:	BIT	7,D
	JR	NZ,L0074
	DEC	C
	SLA	L
	RL	H
	RL	E
	RL	D
	JR	L0073
L0074:	POP	AF
	DEC	A
	JR	NZ,L0071
	POP	AF
	POP	AF
	POP	AF
L0075:	CALL	L0058
	RET
L0076:	XOR	A
	SUB	E
	LD	E,A
	LD	A,00H
	SBC	A,D
	LD	D,A
	LD	A,00H
	SBC	A,C
	LD	C,A
	LD	A,00H
	SBC	A,B
	LD	B,A
	RET
L0078:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	DE,0FDBH
	LD	BC,40C9H
	PUSH	BC
	PUSH	DE
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0063
	POP	HL
	POP	HL
	POP	HL
	POP	HL
	LD	(IX+04H),E
	LD	(IX+05H),D
	LD	(IX+06H),C
	LD	(IX+07H),B
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0010
	POP	HL
	POP	HL
	LD	(0FD12H),DE
	LD	(0FD14H),BC
	LD	DE,(0FD12H)
	LD	BC,(0FD14H)
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,3FC9H
	CALL	L0026
	JR	NZ,L0079
	LD	DE,0000H
	LD	C,E
	LD	B,E
	JP	L0087
L0079:	LD	DE,(0FD12H)
	LD	BC,(0FD14H)
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,3FC9H
	CALL	L0037
	LD	(0FD16H),DE
	LD	(0FD18H),BC
	CALL	L0047
	LD	A,E
	JP	L0084
L0080:	LD	DE,(0FD16H)
	LD	BC,(0FD18H)
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,3FC9H
	CALL	L0029
	LD	(0FD02H),DE
	LD	(0FD04H),BC
	LD	HL,0000H
	LD	(0FD1AH),HL
	JP	L0085
L0081:	LD	DE,(0FD16H)
	LD	BC,(0FD18H)
	CALL	L0025
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,3F80H
	CALL	L0011
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,3FC9H
	CALL	L0029
	LD	(0FD02H),DE
	LD	(0FD04H),BC
	LD	HL,0001H
	LD	(0FD1AH),HL
	JR	L0085
L0082:	LD	DE,(0FD16H)
	LD	BC,(0FD18H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,0C000H
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,3FC9H
	CALL	L0029
	LD	(0FD02H),DE
	LD	(0FD04H),BC
	LD	HL,0001H
	LD	(0FD1AH),HL
	JR	L0085
L0083:	LD	DE,(0FD16H)
	LD	BC,(0FD18H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,0C080H
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,3FC9H
	CALL	L0029
	LD	(0FD02H),DE
	LD	(0FD04H),BC
	LD	HL,0000H
	LD	(0FD1AH),HL
	JR	L0085
L0084:	OR	A
	JP	Z,L0080
	CP	01H
	JP	Z,L0081
	CP	02H
	JR	Z,L0082
	CP	03H
	JR	Z,L0083
L0085:	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
	PUSH	BC
	PUSH	DE
	CALL	L0068
	POP	HL
	POP	HL
	LD	(0FD02H),DE
	LD	(0FD04H),BC
	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,0BF00H
	CALL	L0029
	CALL	L0024
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
	PUSH	BC
	PUSH	DE
	CALL	L0068
	POP	HL
	POP	HL
	LD	(0FD06H),DE
	LD	(0FD08H),BC
	PUSH	BC
	PUSH	DE
	LD	DE,0AAA3H
	LD	BC,3D2AH
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD06H)
	LD	BC,(0FD08H)
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
	CALL	L0029
	LD	(0FD0AH),DE
	LD	(0FD0CH),BC
	PUSH	BC
	PUSH	DE
	LD	DE,099CH
	LD	BC,0BAB6H
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD0AH)
	LD	BC,(0FD0CH)
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
	CALL	L0029
	LD	(0FD0EH),DE
	LD	(0FD10H),BC
	PUSH	BC
	PUSH	DE
	LD	DE,0B40BH
	LD	BC,37CFH
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD0EH)
	LD	BC,(0FD10H)
	PUSH	BC
	PUSH	DE
	LD	DE,0DCE7H
	LD	BC,0B48BH
	CALL	L0029
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
	CALL	L0029
	CALL	L0013
	LD	(0FD02H),DE
	LD	(0FD04H),BC
	LD	HL,(0FD1AH)
	LD	A,L
	OR	H
	JR	Z,L0086
	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
	LD	A,B
	XOR	80H
	LD	B,A
	JR	L0087
L0086:	LD	DE,(0FD02H)
	LD	BC,(0FD04H)
L0087:	POP	IX
	RET
L0088:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	C,E
	LD	B,E
	CALL	L0012
	LD	DE,0000H
	JP	P,L0089
	INC	E
L0089:	LD	(0FD34H),DE
	LD	A,E
	OR	D
	JR	Z,L0090
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	LD	A,B
	XOR	80H
	LD	B,A
	LD	(IX+04H),E
	LD	(IX+05H),D
	LD	(IX+06H),C
	LD	(IX+07H),B
L0090:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,7218H
	LD	BC,42B1H
	CALL	L0012
	JP	M,L0093
	JR	Z,L0093
	LD	HL,(0FD34H)
	LD	A,L
	OR	H
	JR	Z,L0091
	XOR	A
	JR	L0092
L0091:	LD	HL,0002H
	LD	(0FD00H),HL
	LD	DE,0FFFFH
	LD	BC,7F7FH
	JP	L0095
L0092:	CALL	L0053
	JP	L0095
L0093:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,7218H
	LD	BC,3F31H
	CALL	L0037
	LD	(0FD30H),DE
	LD	(0FD32H),BC
	LD	DE,(0FD30H)
	LD	BC,(0FD32H)
	CALL	L0047
	CALL	L0054
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD30H)
	LD	BC,(0FD32H)
	CALL	L0011
	LD	(0FD1CH),DE
	LD	(0FD1EH),BC
	LD	DE,(0FD1CH)
	LD	BC,(0FD1EH)
	PUSH	BC
	PUSH	DE
	LD	DE,727BH
	LD	BC,3F31H
	CALL	L0029
	PUSH	BC
	PUSH	DE
	LD	DE,0FFFFH
	LD	BC,3F7FH
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD1CH)
	LD	BC,(0FD1EH)
	PUSH	BC
	PUSH	DE
	CALL	L0068
	POP	HL
	POP	HL
	LD	(0FD20H),DE
	LD	(0FD22H),BC
	PUSH	BC
	PUSH	DE
	LD	DE,0EAD4H
	LD	BC,3E75H
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD1CH)
	LD	BC,(0FD1EH)
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD20H)
	LD	BC,(0FD22H)
	CALL	L0029
	LD	(0FD24H),DE
	LD	(0FD26H),BC
	PUSH	BC
	PUSH	DE
	LD	DE,0AA23H
	LD	BC,3D64H
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD24H)
	LD	BC,(0FD26H)
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD1CH)
	LD	BC,(0FD1EH)
	CALL	L0029
	LD	(0FD28H),DE
	LD	(0FD2AH),BC
	PUSH	BC
	PUSH	DE
	LD	DE,4806H
	LD	BC,3C13H
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD28H)
	LD	BC,(0FD2AH)
	PUSH	BC
	PUSH	DE
	LD	DE,1905H
	LD	BC,3AF6H
	CALL	L0029
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD1CH)
	LD	BC,(0FD1EH)
	CALL	L0029
	CALL	L0013
	LD	(0FD2CH),DE
	LD	(0FD2EH),BC
	LD	DE,(0FD30H)
	LD	BC,(0FD32H)
	CALL	L0047
	PUSH	DE
	LD	DE,0000H
	LD	BC,3F80H
	PUSH	BC
	PUSH	DE
	CALL	L0067
	POP	HL
	POP	HL
	POP	HL
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD2CH)
	LD	BC,(0FD2EH)
	CALL	L0029
	LD	(0FD2CH),DE
	LD	(0FD2EH),BC
	LD	HL,(0FD34H)
	LD	A,L
	OR	H
	JR	Z,L0094
	LD	DE,0000H
	LD	BC,3F80H
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD2CH)
	LD	BC,(0FD2EH)
	CALL	L0037
	JR	L0095
L0094:	LD	DE,(0FD2CH)
	LD	BC,(0FD2EH)
L0095:	POP	IX
	RET
L0096:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	C,E
	LD	B,E
	CALL	L0012
	JR	Z,L0097
	JP	P,L0100
L0097:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	LD	A,B
	AND	7FH
	OR	C
	OR	D
	OR	E
	JR	NZ,L0098
	LD	A,02H
	JR	L0099
L0098:	LD	A,01H
L0099:	LD	L,A
	RLCA
	SBC	A,A
	LD	H,A
	LD	(0FD00H),HL
	LD	DE,0FFFFH
	LD	BC,0FF7FH
	JP	L0104
L0100:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,3F80H
	CALL	L0026
	JR	NZ,L0101
	LD	DE,0000H
	LD	C,E
	LD	B,E
	JP	L0104
L0101:	LD	HL,0FD42H
	PUSH	HL
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0064
	POP	HL
	POP	HL
	POP	HL
	LD	(0FD36H),DE
	LD	(0FD38H),BC
	LD	DE,(0FD36H)
	LD	BC,(0FD38H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,3F00H
	CALL	L0012
	JR	Z,L0102
	JP	P,L0103
L0102:	LD	DE,(0FD36H)
	LD	BC,(0FD38H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,4000H
	CALL	L0029
	LD	(0FD36H),DE
	LD	(0FD38H),BC
	LD	HL,(0FD42H)
	DEC	HL
	LD	(0FD42H),HL
L0103:	LD	DE,(0FD36H)
	LD	BC,(0FD38H)
	PUSH	BC
	PUSH	DE
	LD	DE,9481H
	LD	BC,0C0C4H
	CALL	L0029
	PUSH	BC
	PUSH	DE
	LD	DE,4BBFH
	LD	BC,0BFB6H
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD36H)
	LD	BC,(0FD38H)
	PUSH	BC
	PUSH	DE
	CALL	L0068
	POP	HL
	POP	HL
	LD	(0FD3AH),DE
	LD	(0FD3CH),BC
	PUSH	BC
	PUSH	DE
	LD	DE,6EA1H
	LD	BC,4087H
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD3AH)
	LD	BC,(0FD3CH)
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD36H)
	LD	BC,(0FD38H)
	CALL	L0029
	LD	(0FD3EH),DE
	LD	(0FD40H),BC
	PUSH	BC
	PUSH	DE
	LD	DE,71A0H
	LD	BC,4055H
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD36H)
	LD	BC,(0FD38H)
	PUSH	BC
	PUSH	DE
	LD	DE,720BH
	LD	BC,4091H
	CALL	L0029
	PUSH	BC
	PUSH	DE
	LD	DE,04F6H
	LD	BC,3EB5H
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD3AH)
	LD	BC,(0FD3CH)
	PUSH	BC
	PUSH	DE
	LD	DE,0B0E3H
	LD	BC,40CDH
	CALL	L0029
	CALL	L0013
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD3EH)
	LD	BC,(0FD40H)
	CALL	L0013
	CALL	L0037
	LD	HL,(0FD42H)
	PUSH	BC
	PUSH	DE
	EX	DE,HL
	CALL	L0054
	PUSH	BC
	PUSH	DE
	LD	DE,7218H
	LD	BC,3F31H
	CALL	L0029
	CALL	L0013
L0104:	POP	IX
	RET
L0105:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	C,E
	LD	B,E
	CALL	L0012
	JR	Z,L0106
	JP	P,L0107
L0106:	LD	HL,0001H
	LD	(0FD00H),HL
	LD	DE,0FFFFH
	LD	BC,0FF7FH
	JR	L0108
L0107:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0096
	POP	HL
	POP	HL
	PUSH	BC
	PUSH	DE
	LD	DE,5D8EH
	LD	BC,4013H
	CALL	L0037
L0108:	POP	IX
	RET
L0109:	LD	HL,0FFFEH
	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	C,(IX+0AH)
	LD	B,(IX+0BH)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	C,E
	LD	B,E
	CALL	L0012
	JR	Z,L0110
	JP	P,L0112
L0110:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	LD	A,B
	AND	7FH
	OR	C
	OR	D
	OR	E
	JR	NZ,L0111
	LD	HL,0001H
	LD	(0FD00H),HL
	LD	DE,0FFFFH
	LD	BC,0FF7FH
	JP	L0118
L0111:	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	C,(IX+0AH)
	LD	B,(IX+0BH)
	LD	A,B
	AND	7FH
	OR	C
	OR	D
	OR	E
	JR	NZ,L0112
	LD	DE,0000H
	LD	BC,3F80H
	JP	L0118
L0112:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	C,E
	LD	B,E
	CALL	L0012
	JP	P,L0113
	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	C,(IX+0AH)
	LD	B,(IX+0BH)
	CALL	L0047
	CALL	L0056
	PUSH	BC
	PUSH	DE
	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	C,(IX+0AH)
	LD	B,(IX+0BH)
	CALL	L0026
	JR	Z,L0113
	LD	HL,0001H
	LD	(0FD00H),HL
	LD	DE,0FFFFH
	LD	BC,0FF7FH
	JP	L0118
L0113:	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	C,(IX+0AH)
	LD	B,(IX+0BH)
	PUSH	BC
	PUSH	DE
	CALL	L0010
	POP	HL
	POP	HL
	LD	(0FD44H),DE
	LD	(0FD46H),BC
	LD	DE,(0FD44H)
	LD	BC,(0FD46H)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	BC,41A8H
	CALL	L0012
	JP	P,L0117
	LD	DE,(0FD44H)
	LD	BC,(0FD46H)
	CALL	L0047
	CALL	L0054
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD44H)
	LD	BC,(0FD46H)
	CALL	L0026
	JP	NZ,L0117
	LD	DE,(0FD44H)
	LD	BC,(0FD46H)
	CALL	L0047
	LD	(IX-02H),E
	LD	(IX-01H),D
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	LD	(0FD44H),DE
	LD	(0FD46H),BC
	LD	L,(IX-02H)
	LD	H,(IX-01H)
	DEC	HL
	LD	(IX-02H),L
	LD	(IX-01H),H
L0114:	LD	L,(IX-02H)
	LD	H,(IX-01H)
	LD	A,L
	OR	H
	JR	Z,L0115
	LD	DE,(0FD44H)
	LD	BC,(0FD46H)
	PUSH	BC
	PUSH	DE
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	CALL	L0029
	LD	(0FD44H),DE
	LD	(0FD46H),BC
	LD	L,(IX-02H)
	LD	H,(IX-01H)
	DEC	HL
	LD	(IX-02H),L
	LD	(IX-01H),H
	JR	L0114
L0115:	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	C,(IX+0AH)
	LD	B,(IX+0BH)
	PUSH	BC
	PUSH	DE
	LD	DE,0000H
	LD	C,E
	LD	B,E
	CALL	L0012
	JP	P,L0116
	LD	DE,0000H
	LD	BC,3F80H
	PUSH	BC
	PUSH	DE
	LD	DE,(0FD44H)
	LD	BC,(0FD46H)
	CALL	L0037
	JR	L0118
L0116:	LD	DE,(0FD44H)
	LD	BC,(0FD46H)
	JR	L0118
L0117:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0096
	POP	HL
	POP	HL
	PUSH	BC
	PUSH	DE
	LD	E,(IX+08H)
	LD	D,(IX+09H)
	LD	C,(IX+0AH)
	LD	B,(IX+0BH)
	CALL	L0029
	PUSH	BC
	PUSH	DE
	CALL	L0088
	POP	HL
	POP	HL
L0118:	LD	SP,IX
	POP	IX
	RET
L0119:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,0BFC9H
	CALL	L0013
	PUSH	BC
	PUSH	DE
	CALL	L0078
	POP	HL
	POP	HL
	POP	IX
	RET
L0120:	PUSH	IX
	LD	IX,0000H
	ADD	IX,SP
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0010
	POP	HL
	POP	HL
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,3FC9H
	CALL	L0026
	JR	NZ,L0121
	LD	HL,0002H
	LD	(0FD00H),HL
	LD	DE,0FFFFH
	LD	BC,7F7FH
	JR	L0123
L0121:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0010
	POP	HL
	POP	HL
	PUSH	BC
	PUSH	DE
	LD	DE,1D7DH
	LD	BC,2690H
	CALL	L0012
	JP	P,L0122
	LD	DE,0000H
	LD	C,E
	LD	B,E
	JR	L0123
L0122:	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	LD	DE,0FDBH
	LD	BC,0BFC9H
	CALL	L0013
	PUSH	BC
	PUSH	DE
	CALL	L0078
	POP	HL
	POP	HL
	PUSH	BC
	PUSH	DE
	LD	E,(IX+04H)
	LD	D,(IX+05H)
	LD	C,(IX+06H)
	LD	B,(IX+07H)
	PUSH	BC
	PUSH	DE
	CALL	L0078
	POP	HL
	POP	HL
	CALL	L0037
L0123:	POP	IX
	RET
